function instanceAppend(str) {
	return widget.identifier + "-" + str;
}

/* Object definition which stores preferences */
/* these include:
	- zipCode (which can be a query as well)
	- preferred units
	- drawer state (photos or weekForecast)
	- widget state (minimized,normal,drawer)
	- rightContent state (radar,conditions,wundercam)
	- localWxStnType (airport or PWS)
	- localWxStnId (either ICAO or PWS number)
	- photoFeed
	- city
	- sublocation

	Note: when instantiated, the preference object will auto-fill the 'zip' text box
*/

var prefs;

function Preferences() {
	
	this.getUrl = function () {
		return widget.preferenceForKey(instanceAppend("url"));
	};
	this.setUrl = function (str) {
		widget.setPreferenceForKey(str,instanceAppend("url"));
	};
	this.getNiceUrl = function () {
		return widget.preferenceForKey(instanceAppend("niceurl"));
	};
	this.setNiceUrl = function (str) {
		widget.setPreferenceForKey(str,instanceAppend("niceurl"));
	};
	this.getQuery = function () {
		return widget.preferenceForKey(instanceAppend("query"));
	};
	this.setQuery = function (str) {
		widget.setPreferenceForKey(str,instanceAppend("query"));
	};
	
	this.getUnits = function ()
	{
		return widget.preferenceForKey(instanceAppend("units"));
	};
	this.setUnits = function(str) {
		widget.setPreferenceForKey(str,instanceAppend("units"));
		$('unitSelector').selectedIndex = str;
	};
	
	this.getDrawerState = function () {
		return widget.preferenceForKey(instanceAppend("drawerState"));
	};
	this.setDrawerState = function (str) {
		widget.setPreferenceForKey(str,instanceAppend("drawerState"));
	};
	this.getDrawerStateOpen = function () {
		return widget.preferenceForKey(instanceAppend("drawerStateOpen"));
	};
	this.setDrawerStateOpen = function (str) {
		widget.setPreferenceForKey(str,instanceAppend("drawerStateOpen"));
	};
	
	this.getWidgetState = function () {
		return widget.preferenceForKey(instanceAppend("widgetState"));
	};
	this.setWidgetState = function (str) {
		widget.setPreferenceForKey(str,instanceAppend("widgetState"));
	};
	
	this.getRightContentState = function () {
		return widget.preferenceForKey(instanceAppend("rightContentState"));
	};
	this.setRightContentState = function (str) {
		widget.setPreferenceForKey(str,instanceAppend("rightContentState"));
	};
	this.getPWSId = function () {
		return widget.preferenceForKey(instanceAppend("PWS"));
	};
	this.setPWSId = function (str) {
		widget.setPreferenceForKey(str,instanceAppend("PWS"));
	};

	this.getAirportId = function () {
		return widget.preferenceForKey(instanceAppend("airport"));
	};
	this.setAirportId = function (str) {
		widget.setPreferenceForKey(str,instanceAppend("airport"));
	};
	this.getPhotoFeed = function () {
		return widget.preferenceForKey(instanceAppend("photoFeed"));
	};
	this.setPhotoFeed = function (str) {
		widget.setPreferenceForKey(str,instanceAppend("photoFeed"));
	};
	this.getLocation = function () {
		return widget.preferenceForKey(instanceAppend("location"));
	};
	this.setLocation = function (str) {
		widget.setPreferenceForKey(str,instanceAppend("location"));
		$('location').innerHTML = str;
	};
	this.getSubLocation = function () {
		return widget.preferenceForKey(instanceAppend("subLocation"));
	};
	this.setSubLocation = function (str) {
		widget.setPreferenceForKey(str,instanceAppend("subLocation"));
		$('sub-location').innerHTML = str;
	};
	this.setLoc = function (obj) {
		widget.setPreferenceForKey(obj.toJSONString(),instanceAppend("loc"));
	};
	this.getLoc = function () {
		eval('var obj='+widget.preferenceForKey(instanceAppend("loc")));
		return obj;
	};
  this.getWebcam = function () {
    return widget.preferenceForKey(instanceAppend("webcam"));
  };
	this.setWebcam = function(str) {
	  widget.setPreferenceForKey(str,instanceAppend("webcam"));
	}; 
}