function toMs(minutes) {
  return minutes * 60 * 1000;
} 
function now() { //in seconds
  return parseInt((new Date()).getTime() /1000,10);
}

function loadTimeouts() {
  Timeout_retrieve(Timeout_parseData,Timeout_connectionProblem);
}

var curTime = now();
var timeouts = {
  'fcst':{"value":null,"id":null,"lastUpdate":curTime},
  'PWS':{"value":null,"id":null,"lastUpdate":curTime},
  'ICAO':{"value":null,"id":null,"lastUpdate":curTime},
  'alert':{"value":null,"id":null,"lastUpdate":curTime},
  'photos':{"value":null,"id":null,"lastUpdate":curTime},
  'radar':{"value":null,"id":null,"lastUpdate":curTime},
  'webcam':{"value":null,"id":null,"lastUpdate":curTime},
  'self':{"value":null,"id":null,"lastUpdate":curTime}
};
delete curTime;

var Timeout_state = 'running';
var Timeout_pausedAt = now();

Timeout_TIMEOUT = 6000;

function Timeout_retrieve(callback, error_loading) {
  var url = "http://api.wunderground.com/auto/wui/geo/Timeouts/index.xml";
  
  Timeout_state = 'running';
  Timeout_pausedAt = now();

  var request = new XMLHttpRequest();
  request.onreadystatechange = onReadyStateChange;
  request.overrideMimeType('application/json');
  request.open("GET", url, true);
  request.setRequestHeader("Cache-Control", "no-cache");
  request.send();

  var requestTimeout = view.setTimeout(function() { request.abort(); if (error_loading) {error_loading();}}, Timeout_TIMEOUT);   

  function onReadyStateChange() {
    if (request.readyState != 4) {
      return;
    }
  
    view.clearTimeout(requestTimeout);
    
    if (request.status == 200) {
      Timeout_parseData(request.responseText, Timeout_setTimeouts, error_loading);
    } else {
      if (error_loading) {
        error_loading(); 
      } 
    }
  }
}

function Timeout_parseData(responseText, callback, error_loading) {
  var receivedTimeouts;
  
  try {
    //should load data the same as the default values above
    eval('receivedTimeouts = ' + responseText);
    
    if (receivedTimeouts.latestVersion > Widget_VERSION) {
      Widget_setUpgradeDialog(receivedTimeouts.latestVersion,receivedTimeouts.latestVersionLink);
    } else {
      Widget_upgradeAlert = null;
    }
    
    if (callback) callback(receivedTimeouts);
    
  } catch(e) {
    debug.error("Timeout_parseData: eval failed. \n"+e);
    if (error_loading) error_loading(callback);
  } 
}
function Timeout_connectionProblem (callback) {
  debug.error("Couldn't receive connection");
  
  receivedTimeouts = {
      'forecast': 120,
      'PWS'     : 5,
      'ICAO'    : 20,
      'photos'  : 60,
    'radar'   : 5,
    'webcam'  : 2,
    'alert'  : 5,
      'selfTimeout' : 60
  };
  if (callback) callback(receivedTimeouts);
}

function Timeout_setTimeouts (receivedTimeouts) {

  if (timeouts.fcst.value != receivedTimeouts.forecast || !timeouts.fcst.id) {//changed since our last update or first time
    timeouts.fcst.value = receivedTimeouts.forecast;  
    if (timeouts.fcst.id) {window.clearTimeout(timeouts.fcst.id);}
    timeouts.fcst.id = window.setTimeout('reloadForecastData()',toMs(timeouts.fcst.value));
  }
  if (timeouts.PWS.value != receivedTimeouts.PWS || !timeouts.PWS.id) {//changed since our last update or first time
    timeouts.PWS.value = receivedTimeouts.PWS;
    if (timeouts.PWS.id) {window.clearTimeout(timeouts.PWS.id);}
    timeouts.PWS.id = window.setTimeout('reloadPWSData()',toMs(timeouts.PWS.value));
  }
  if (timeouts.ICAO.value != receivedTimeouts.ICAO || !timeouts.ICAO.id) {
    timeouts.ICAO.value = receivedTimeouts.ICAO;
    if (timeouts.ICAO.id) {window.clearTimeout(timeouts.ICAO.id);}
    timeouts.ICAO.id = window.setTimeout('reloadICAOData()',toMs(timeouts.ICAO.value));
  }
  if (timeouts.radar.value != receivedTimeouts.radar || !timeouts.radar.id) {
    timeouts.radar.value = receivedTimeouts.radar;
    if (timeouts.radar.id) {window.clearTimeout(timeouts.radar.id);}
    timeouts.radar.id = window.setTimeout('reloadRadarData()',toMs(timeouts.radar.value));
  }
  if (timeouts.webcam.value != receivedTimeouts.webcam || !timeouts.webcam.id) {
    timeouts.webcam.value = receivedTimeouts.webcam;
    if (timeouts.webcam.id) {window.clearTimeout(timeouts.webcam.id);}
    timeouts.webcam.id = window.setTimeout('reloadWebcamData()',toMs(timeouts.webcam.value));
  }
  if (timeouts.photos.value != receivedTimeouts.photos || !timeouts.photos.id) {
    timeouts.photos.value = receivedTimeouts.photos;
    if (timeouts.photos.id) {window.clearTimeout(timeouts.photos.id);}
    timeouts.photos.id = window.setTimeout('reloadPhotosData()',toMs(timeouts.photos.value));
  }
  if (timeouts.alert.value != receivedTimeouts.alert || !timeouts.alert.id) {
    timeouts.alert.value = receivedTimeouts.alert;
    if (timeouts.alert.id) {window.clearTimeout(timeouts.alert.id);}
    timeouts.alert.id = window.setTimeout('reloadAlertData()',toMs(timeouts.alert.value));
  }
  if (timeouts.self.value != receivedTimeouts.selfTimeout || !timeouts.self.id) {
    timeouts.self.value = receivedTimeouts.selfTimeout;
    if (timeouts.self.id) {window.clearTimeout(timeouts.self.id);}
    timeouts.self.id = window.setTimeout('reloadTimeoutData()',toMs(timeouts.self.value));
  }
  
}

function Timeout_clearTimeouts () {
  if (timeouts.fcst.id) {window.clearTimeout(timeouts.fcst.id); timeouts.fcst.id = -1;}
  if (timeouts.PWS.id) {window.clearTimeout(timeouts.PWS.id); timeouts.PWS.id = -1;}
  if (timeouts.ICAO.id) {window.clearTimeout(timeouts.ICAO.id); timeouts.ICAO.id = -1;}
  if (timeouts.photos.id) {window.clearTimeout(timeouts.photos.id); timeouts.photos.id = -1;}
  if (timeouts.radar.id) {window.clearTimeout(timeouts.radar.id); timeouts.radar.id = -1; }
  if (timeouts.webcam.id) {window.clearTimeout(timeouts.webcam.id); timeouts.webcam.id = -1; }
  if (timeouts.alert.id) {window.clearTimeout(timeouts.alert.id); timeouts.alert.id = -1; }
  if (timeouts.self.id) {window.clearTimeout(timeouts.self.id); timeouts.self.id = -1; }
}

function Timeout_pauseTimeouts() {
  Timeout_clearTimeouts();
  Timeout_state = 'paused';
  Timeout_pausedAt = now(); 
}

function Timeout_resumeTimeouts() {
  var remaining;
  var curTime = now();
  
  //catch the first time, when we're still visible
  if (Timeout_state == 'running') return;

  Timeout_state = 'running';

  //these execute on every onShow
  reloadICAOData();
  
  reloadPWSData(); 

  reloadAlertData();

  //determine whether to update or wait
  if ((curTime - timeouts.radar.lastUpdate) >= timeouts.radar.value*60) {
    reloadRadarData();
  } else {
    remaining = timeouts.radar.value*60 - (curTime - timeouts.radar.lastUpdate);
    timeouts.radar.id = window.setTimeout('reloadRadarData()',remaining * 1000);
  }
  
  if ((curTime - timeouts.webcam.lastUpdate) >= timeouts.webcam.value*60) {
    reloadWebcamData();
  } else {
    remaining = timeouts.webcam.value*60 - (curTime - timeouts.webcam.lastUpdate);
    timeouts.webcam.id = window.setTimeout('reloadWebcamData()',remaining * 1000);
  }

  if ((curTime - timeouts.fcst.lastUpdate) >= timeouts.fcst.value*60) {
    reloadForecastData();
  } else {
    remaining = timeouts.fcst.value*60 - (curTime - timeouts.fcst.lastUpdate);
    timeouts.fcst.id = window.setTimeout('reloadForecastData()',remaining * 1000);
  }
  
  if ((curTime - timeouts.self.lastUpdate) >= timeouts.self.value*60) {
    reloadTimeoutData();
  } else {
    remaining = timeouts.self.value*60 - (curTime - timeouts.self.lastUpdate);
    timeouts.self.id = window.setTimeout('reloadTimeoutData()',remaining * 1000);
  }

  if ((curTime - timeouts.photos.lastUpdate) >= timeouts.photos.value*60) {
    reloadPhotosData();
  } else {
    remaining = timeouts.photos.value*60 - (curTime - timeouts.photos.lastUpdate);
    timeouts.photos.id = window.setTimeout('reloadPhotosData()',remaining * 1000);
  }
}

function reloadTimeoutData() {
  timeouts.self.lastUpdate = now(); 
  timeouts.self.id = window.setTimeout('reloadTimeoutData()',toMs(timeouts.self.value));
  loadTimeouts();
}
function reloadForecastData() {
  timeouts.fcst.lastUpdate = now();
  timeouts.fcst.id = window.setTimeout('reloadForecastData()',toMs(timeouts.fcst.value));
  
  debug.trace("reloadForecastData: Reloading forecast");
  Forecast_retrieve(setForecast, Forecast_errorLoading);
}
function reloadPWSData() {
  timeouts.PWS.lastUpdate = now();
  timeouts.PWS.id = window.setTimeout('reloadPWSData()',toMs(timeouts.PWS.value)); 
  
  if (prefs.getPWSId() != null) {
    debug.trace("reloadPWSData: Reloading pws");
    CurCond_retrieve('pws', false, setCurConds, CurCond_errorLoading);
  }
}
function reloadICAOData() {
  timeouts.ICAO.lastUpdate = now();
  timeouts.ICAO.id = window.setTimeout('reloadICAOData()',toMs(timeouts.ICAO.value));
  
  if (prefs.getAirportId() != null) {
      var no_overwrite = prefs.getPWSId() != null ? true : false;
       
    debug.trace("reloadICAOData: Reloading airport w/ no_overwrite = ["+(no_overwrite ? "true":"false")+"]");
    CurCond_retrieve('airport', no_overwrite, setCurConds, CurCond_errorLoading);
  }
}

function reloadPhotosData() {
  timeouts.photos.lastUpdate = now();
  timeouts.photos.id = window.setTimeout('reloadPhotosData()',toMs(timeouts.photos.value));
  
  debug.trace("reloadPhotosData: Reloading photos");
  Photos_retrieve(null, Photos_loadPhotos);
}
function reloadRadarData() {
  timeouts.radar.lastUpdate = now();
  timeouts.radar.id = window.setTimeout('reloadRadarData()',toMs(timeouts.radar.value));
  
  if (loc && loc.radar.image) {
      debug.trace("reloadRadarData: Reloading radar");
      $('radar').src = (loc.radar.image ? loc.radar.image : RADAR_BLANK);
  }
}
function reloadWebcamData() {
  timeouts.webcam.lastUpdate = now();
  timeouts.webcam.id = window.setTimeout('reloadWebcamData()',toMs(timeouts.webcam.value));

  try {
  var webcam;
  if (prefs.getRightContentState() == 'wundercam' && loc && (webcam = loc.webcams[prefs.getWebcam()])) {
      debug.trace("reloadWebcamData: Reloading webcam");
      Widget_createWebcamImage(webcam);
  }
  } catch(e) {
    debug.error("reloadWebcamData: "+e.message);
  }
}

function reloadAlertData() {
  timeouts.alert.lastUpdate = now();
  timeouts.alert.id = window.setTimeout('reloadAlertData()',toMs(timeouts.alert.value));
  
  debug.trace("reloadAlertData: Reloading alert");
  Alert_retrieve(setAlert,Alert_errorLoading);
}