function MoveSet (eles, moveDistance, moveDuration, onFinished,leftBounds,rightBounds) {
	this.eles = eles;
	this.moveDistance = moveDistance;
	this.duration = moveDuration;
	this.onFinished = onFinished;
	this.leftBounds = leftBounds;
	this.rightBounds = rightBounds;
	// this.elesLeft = new Array();
	
	this.direction;

	//sets speed of scroll
	this.multiplier = 1;	
	
	// min and max represent the start and end position, respectively
	this.minPosition = parseInt(this.eles.item(0).style.left,10);

	this.maxPosition = this.minPosition + this.moveDistance;
	
	// Set variables to what they'd be in beginning state
	this.positionFrom = this.minPosition;
	
	this.positionTo = this.maxPosition;
		
	// new AppleClasses support
	var self = this; // eliminates scope problems in timers/event handlers
	
	this.moveAnimator = null;
		
	// AppleAnimation callback; this is where we actually change the size
	this.nextFrame = function (animation, now, first, done) {
		//loop through all elements
		for(var i = 0; i < eles.length; i++) {
			// elesLeft += now;

			self.eles.item(i).style.left = (now + i*100) + "px";
		}
	};
	
	// Callback for AppleAnimator; also called to interrupt a move
	this.doneMoving = function() {

		//set min again to the first element
		self.positionFrom = parseInt(self.eles.item(0).style.left,10);
		
		delete self.moveAnimator;
		if (self.onFinished) {
			self.onFinished();
		}
	};

}

MoveSet.prototype.move = function (event,direction) {
	this.direction = direction;
	
	if (event && event != undefined && event.shiftKey) {
		// enable slo-mo
		this.multiplier = 10;
	} else this.multiplier = 1;

	//prevent the mover from going over the predefined edges
	if (this.checkBounds() == false)
		return false;

	//determine which way to move
	if (this.direction == 'left')
		this.positionTo = this.positionFrom + this.moveDistance;
	else
		this.positionTo = this.positionFrom - this.moveDistance;
	//note we can't interrupt it once it begins
	if (!this.moveAnimator){
	this.moveAnimator = new AppleAnimator(this.duration * this.multiplier, 13, this.positionFrom, this.positionTo, this.nextFrame);
	this.moveAnimator.oncomplete = this.doneMoving;
	this.moveAnimator.start();
	}
};

MoveSet.prototype.checkBounds = function() {
	var farthest;
	
	if (this.leftBounds || this.rightBounds) {
		farthest = this.findFarthestPic(this.direction);
		//compare again 5 px for the leftmost image, or 205px for the
		if (this.direction == 'left' ? farthest >= this.leftBounds : farthest <= this.rightBounds ) {
			return false;
		}
	}
	return true;
};

MoveSet.prototype.findFarthestPic = function(direction) {
	var farthest; 
	var first;
	
	if (first = this.eles.item(0)) {
		farthest = parseInt(first.style.left,10);
	}
	else farthest = -200; //arbitrary starting value
	
	for(var i = 0; i < this.eles.length; i++) {
		var left = parseInt(this.eles.item(i).style.left,10);
		
		//if direction is left, check for leftmost, else check for farthest right
		if (direction == 'left' ? left < farthest : left > farthest) {
			farthest = left;
		}
	}
	
	return farthest;
};