var Forecast_TIMEOUT = 10000;
var Forecast_forecastData;

function Forecast_retrieve(callback, error_loading) {
  var url = "http://api.wunderground.com/auto/wui/geo/ForecastXML" + prefs.getUrl();
  var hasBeenLoaded = false;
  
  var request = newXMLHttpRequest();
  if (!request) {if (error_loading) {error_loading();} return;}
  request.onreadystatechange = onReadyStateChange;
  if (request.overrideMimeType) request.overrideMimeType('text/xml');
  request.open("GET", url, true);
  request.setRequestHeader("Cache-Control", "no-cache");
  
  var requestTimeout = view.setTimeout(function() { request.abort(); if (error_loading) {error_loading();}}, Forecast_TIMEOUT);   
  
  request.send();

  function onReadyStateChange() {
    if (request.readyState != 4 || hasBeenLoaded == true) {
      return;
    }
    hasBeenLoaded = true;
	  
    view.clearTimeout(requestTimeout);
    
    if (request.status == 200) {
			debug.trace("Forecast_parseData loaded");
      Forecast_parseData(request.responseXML, callback, error_loading);
    } else {
      if (error_loading) {
        error_loading(); 
      } 
    }
  }
}

function Forecast_parseData(xml, callback, error_loading) {
	
  try {
	var forecast = new Object();
	var forecastNode = findChild(xml,"forecast");
	
  // for the text forecast (NWS)
  var txt_forecast = findChild(forecastNode,"txt_forecast");
  forecast.txtFcsts = new Array();
  forecast.txtFcstDate = findChildData(txt_forecast,"date");
  var forecasts = findChildList(txt_forecast,"forecastday");
  for (var i = 0; i < forecasts.length; i++) {
   var fcst = new Object();
   fcst.title = findChildData(forecasts[i],"title");
   fcst.text = findChildData(forecasts[i],"fcttext");
   forecast.txtFcsts.push(fcst);
  }
	
	//simple forecast, for the week
  forecast.weekFcsts = new Array();
  var simpleFcsts = findChild(forecastNode,"simpleforecast"); 
  var forecasts = new Array();
  forecasts = findChildList(simpleFcsts,"forecastday");
  
  for (var i = 0; i < forecasts.length; i++) {
   var day = new Object();
   day.day = findChildData(findChild(forecasts[i],"date"),"weekday");
   var high = findChild(forecasts[i],"high");
   day.high = [
     findChildData(high,"fahrenheit"),
     findChildData(high,"celsius")
   ];
   var low = findChild(forecasts[i],"low");
   day.low = [
     findChildData(low,"fahrenheit"),
     findChildData(low,"celsius")
   ];
   day.conditions = findChildData(forecasts[i],"conditions");
   day.icon = findChildData(forecasts[i],"icon");
   forecast.weekFcsts.push(day);
  }  
	
	//Moon phases
	forecast.moon = new Object();
	var moonNode = findChild(forecastNode,"moon_phase");
  var curTimeNode = findChild(moonNode,"current_time");
  forecast.moon.curHour = findChildData(curTimeNode,"hour");
  forecast.moon.curMin = findChildData(curTimeNode,"minute");
	forecast.moon.age = findChildData(moonNode,"ageOfMoon");
	forecast.moon.percent = findChildData(moonNode,"percentIlluminated");
	var sunset = findChild(moonNode,'sunset');
	forecast.moon.sunsetHour = findChildData(sunset,"hour");
	forecast.moon.sunsetMin = findChildData(sunset,"minute");
	var sunrise = findChild(moonNode,"sunrise");
	forecast.moon.sunriseHour = findChildData(sunrise,"hour");
	forecast.moon.sunriseMin = findChildData(sunrise,"minute");
	
	} catch(e) {
     debug.error("Forecast_parseData: " + e.message);
     if (error_loading) {
       error_loading();
     }
	}

	Forecast_forecastData = forecast;
	if (callback) callback(forecast);
}
function Forecast_errorLoading() {
	debug.error("Forecast_errorLoading: connection problem");	
}